extends Control

var _text:String = ""

onready var label = $VBoxContainer/Label

func _ready() -> void:
	_clear()

	var tbl = [
		$VBoxContainer/HBoxContainer4/Button0,
		$VBoxContainer/HBoxContainer3/Button1,
		$VBoxContainer/HBoxContainer3/Button2,
		$VBoxContainer/HBoxContainer3/Button3,
		$VBoxContainer/HBoxContainer2/Button4,
		$VBoxContainer/HBoxContainer2/Button5,
		$VBoxContainer/HBoxContainer2/Button6,
		$VBoxContainer/HBoxContainer/Button7,
		$VBoxContainer/HBoxContainer/Button8,
		$VBoxContainer/HBoxContainer/Button9,
	]
	
	for i in range(10):
		var btn = tbl[i]
		# 各数値ボタンの "pressed" に接続する.
		btn.connect("pressed", self, "_on_NumButton_pressed", [i])
		

func _clear() -> void:
	_text = ""

# 更新.
func _process(delta: float) -> void:
	if _text == "":
		label.text = "0"
	else:
		label.text = _text
	
func add_text(s:String) -> void:
	_text += s

func _on_NumButton_pressed(num:int) -> void:
	add_text(str(num))

func _on_ButtonAC_pressed() -> void:
	_clear()

# 加算演算子
func _on_ButtonAdd_pressed() -> void:
	add_text("+")

# 減算演算子
func _on_ButtonSub_pressed() -> void:
	add_text("-")

# 乗算演算子
func _on_ButtonMul_pressed() -> void:
	add_text("*")

# 除算演算子
func _on_ButtonDiv_pressed() -> void:
	add_text("/")

# 計算する
func _on_ButtonEq_pressed() -> void:
	var expression = Expression.new()
	expression.parse(_text)
	var result = expression.execute()

	# "33" と出力される
	print(result)

	_text = str(result)
